######################################
## ANALYSIS OF ENRON CORPUS
######################################

rm(list=ls())

# set path: data
# setwd("data")

######################################
## EXECUTING THIS FILE TAKES A VERY LONG TIME 
## EVEN ON A SERVEUR WITH 64 CORES IT WILL TAKE WEEKS!!!
######################################

# source the VEM-algorithm
setwd("../code")
source('vem_dynppsbm.R')
source('bootstrap.R')
setwd("../data")

## load data
load("Enron_data.Rdata")   

## set parameters
n <- 147
nb.coeurs <- detectCores()

######################################
## Apply VEM-algorithm to Enron data
######################################

## compute VEM solution
sol_enron <- dynppSBM(data,n,Qmin=1,Qmax=20,cores=nb.coeurs,l_part=6,n_perturb=10,perc_perturb=.2,filename = 'Enron_solution.Rdata')


######################################
# Compute bootstrap confidence intervals for estimatros alpha^(q,l)
######################################

Q <- 4
solQ <- sol_enron[[Q]]
filename <- 'Enron_bootstrap_results.RData' #bootsol_enron_june_1.RData'
Time <- 67248095
R <- 1190
boot.sol <- bootstrapCI(solQ,Time,R,alpha=0.05,nbcores=nb.coeurs,l_part=3,n_perturb=5,perc_perturb=.2,directed=T,filename=filename)


######################################
# Classical SBM analysis
######################################

## load data
load("Enron_data_SBM.Rdata")

fichier <- 'Enron_solution_SBM.Rdata'

## compute VEM solution
sol_enron <- dynppSBM(data,n,Qmin=1,Qmax=20,cores=nb.coeurs,l_part=0,n_perturb=100,perc_perturb=.2,filename=fichier)


######################################
# Sparse model
######################################

## load data
load("Enron_data.Rdata")   

fichier <- 'Enron_solution_sparse.Rdata'

## compute VEM solution
sol_enron <- dynppSBM(data,n,Qmin=1,Qmax=15,sparse=TRUE,cores=nb.coeurs,l_part=3,n_perturb=5,perc_perturb=.3,filename=fichier)

