##############################
### Simulations first scenario
##############################

rm(list=ls())
source('generator.R')
#setwd("../code")
source('vem_dynppsbm.R')
source('output.R')
#setwd("../simulations/")

### Setup - model 
nb.obs <-  c(10,30) 
REP <- 1000 
PHI <- c(.01, .05, 0.1, .2, .5)
nb.phi <- length(PHI)
Q <- 2
prop.groups <- rep(1/2,2)
Time <- 1 

sin.in <- function(x){
  return(10*sin(x*2*pi)+10)
}
sin.out <- function(x){
  # careful: parameter phi is taken from the environment
  return(10*sin((x+phi)*2*pi)+10)
}

#### Figures of intensities from Scenario 1 
# library(ggplot2)
# library(gridExtra)
# library("reshape2")
# g_legend<-function(a.gplot){
#   tmp <- ggplot_gtable(ggplot_build(a.gplot))
#   leg <- which(sapply(tmp$grobs, function(x) x$name) == "guide-box")
#   legend <- tmp$grobs[[leg]]
#   return(legend)}
# 
# step = .01
# x <- seq(0,1,by=step)
# sin.in.x <- sin.in(x)
# plot.list <-list()
# # First plot
# phi=.01#, .05, 0.1, .2, .5
# data.plot <- data.frame(Time=x,alpha.in=sin.in.x,alpha.out=sin.out(x))
# data.plot.long <- melt(data.plot, id="Time")  # convert to long format
# plot.list[[1]] <-ggplot(data=data.plot.long,
#                             aes(x=Time, y=value,linetype = variable)) +
#     geom_line() + labs(title =expression(varphi~"="~.01),y="Intensities",linetype = "")  
# # second plot
# phi=.05#, 0.1, .2, .5
# data.plot <- data.frame(Time=x,alpha.in=sin.in.x,alpha.out=sin.out(x))
# data.plot.long <- melt(data.plot, id="Time")  # convert to long format
# plot.list[[2]] <-ggplot(data=data.plot.long,
#                         aes(x=Time, y=value,linetype = variable)) +
#   geom_line() + labs(title =expression(varphi~"="~.05),y="Intensities",linetype = "")  
# # third plot
# phi= 0.1#, .2, .5
# data.plot <- data.frame(Time=x,alpha.in=sin.in.x,alpha.out=sin.out(x))
# data.plot.long <- melt(data.plot, id="Time")  # convert to long format
# plot.list[[3]] <-ggplot(data=data.plot.long,
#                         aes(x=Time, y=value,linetype = variable)) +
#   geom_line() + labs(title =expression(varphi~"="~.1),y="Intensities",linetype = "")  
# # fourth plot
# phi=.2#, .5
# data.plot <- data.frame(Time=x,alpha.in=sin.in.x,alpha.out=sin.out(x))
# data.plot.long <- melt(data.plot, id="Time")  # convert to long format
# plot.list[[4]] <-ggplot(data=data.plot.long,
#                         aes(x=Time, y=value,linetype = variable)) +
#   geom_line() + labs(title =expression(varphi~"="~.2),y="Intensities",linetype = "")  
# # fifth plot
# phi=.5
# data.plot <- data.frame(Time=x,alpha.in=sin.in.x,alpha.out=sin.out(x))
# data.plot.long <- melt(data.plot, id="Time")  # convert to long format
# plot.list[[5]] <-ggplot(data=data.plot.long,
#                         aes(x=Time, y=value,linetype = variable)) +
#   geom_line() + labs(title =expression(varphi~"="~.5),y="Intensities",linetype = "")  
# ###
# mylegend <- g_legend(plot.list[[1]])
# plot.r1 <- arrangeGrob(plot.list[[1]] + theme(legend.position="none"), plot.list[[2]]  + theme(legend.position="none"),plot.list[[3]] + theme(legend.position="none"), nrow=1)
# plot.r2 <-arrangeGrob(plot.list[[4]] + theme(legend.position="none"), plot.list[[5]]  + theme(legend.position="none"), mylegend, nrow=1)
# last.plot <- grid.arrange(plot.r1,plot.r2,nrow=2)
# ggsave("fig_intensites_Q2.pdf",last.plot, width = 6.2,height=4)
#######


# Store intensities as a list 
Max.sin <- 20.1
intens <- list(NULL)
intens[[1]] <- list(intens=sin.in,max=Max.sin) 	# (q,l) = (1,1)  in
intens[[2]] <- list(intens=sin.out,max=Max.sin)	# (q,l) = (1,2)  out
intens[[3]] <- list(intens=sin.in,max=Max.sin) 	# (q,l) = (2,2)  in

## setup - algorithm
Dmax <- 2^3  #8 # dyadic partition used for histograms

### Generate datasets + estimate + compute ARI 
# Warning: do not use multiple cores with set.seed
# choose value of n here
#n<-10
n<-30
resARI.hist <- matrix(NA,REP,nb.phi)
resARI.ker <- matrix(NA,REP,nb.phi)

for (k in 1:nb.phi){
  phi <- PHI[k]
  for (rep in 1:REP){
    cat('*********** phi=', phi, '******* repetition ', rep,'***********\n')
    set.seed((k-1)*REP+rep)
    obs <- generat.dynppSBM(intens,Time,n,prop.groups,directed=FALSE)
    
    # Histogram method
    # Compute statistics for histogram method 
    obs.dyad5 <- list(Time=obs$data$Time,Nijk = statistics(obs$data,n,Dmax,directed=FALSE))
    set.seed((k-1)*REP+rep) # same initialisation of both methods
    sol.hist <- dynppSBM(obs.dyad5,n,Q,directed=FALSE,l_part=2,n_perturb=2,n_random=2)[[1]]
    # default values sparse=FALSE,method='hist',perc_perturb=.2,n_random=0,nb.iter=50,fix.iter=10,epsilon=1e-6

    # Kernel method 
    set.seed((k-1)*REP+rep) # same initialisation of both methods
    sol.kernel <- dynppSBM(obs$data,n,Q,directed=FALSE,method='kernel',l_part=2,n_perturb=2,n_random=2)[[1]]
    # default values sparse=FALSE,perc_perturb=.2,nb.iter=50,fix.iter=10,epsilon=1e-6
    resARI.hist[rep,k] <- ARI(obs$z,sol.hist$tau)
    resARI.ker[rep,k] <- ARI(obs$z,sol.kernel$tau)
  }
}

# save results
results <- cbind(resARI.ker,resARI.hist)
write.table(results, file=paste('results-ARI-n-',n,'-rep-',REP,'.txt',sep=""))
file=paste('ARI_scenar1_n',n,'.Rdata',sep="")
save(resARI.hist,resARI.ker,file=file)


#####
## Output boxplots 
library('ggplot2')
library('gridExtra')
g_legend<-function(a.gplot){
  tmp <- ggplot_gtable(ggplot_build(a.gplot))
  leg <- which(sapply(tmp$grobs, function(x) x$name) == "guide-box")
  legend <- tmp$grobs[[leg]]
  return(legend)}


vec.at <- seq(1,17,by=4)
load("ARI_scenar1_n10.Rdata")
phi <- factor(rep(rep(1:5,rep(1000,5)),2),labels=c(0.01,0.05,0.1,0.2,0.5))
method <- factor(rep(c(1,2),c(5000,5000)),labels=c('hist','ker'))
ARI.n10 <- data.frame(ARI= as.vector(c(resARI.hist,resARI.ker)),phi,method)
plot1 <- ggplot(ARI.n10,aes(x=phi,y=ARI,fill=method,dodge=method)) +  
  geom_boxplot() + xlab(expression(varphi))+ 
  scale_fill_grey(start=0.5, end=1) + theme(legend.position="bottom") + 
  ggtitle("n=10") +theme(plot.title = element_text(hjust = 0.5))
mylegend<-g_legend(plot1)
load("ARI_scenar1_n30.Rdata")
ARI.n30 <- data.frame(ARI= as.vector(c(resARI.hist,resARI.ker)),phi,method)
plot2<- ggplot(ARI.n30,aes(x=phi,y=ARI,fill=method,dodge=method)) +  
  geom_boxplot() + xlab(expression(varphi))+ 
  scale_fill_grey(start=0.5, end=1) + ggtitle("n=30") +
  theme(plot.title = element_text(hjust = 0.5))
# Final plot
final.plot <- grid.arrange(arrangeGrob(plot1 + theme(legend.position="none"), plot2 + theme(legend.position="none"), nrow=1),mylegend, nrow=2,heights=c(10,1))
ggsave("boxplot_scen1_n10_n30.pdf",plot=final.plot, width = 6.5,height=3)


#######



